#include <SFML/Window.hpp>
#include "opengl/renderer.hpp"

#define WIDTH 1200
#define HEIGHT 800

int main(int argc, char *argv[])
{
	// Init SFML
	sf::ContextSettings settings;
	settings.depthBits = 24;
	settings.stencilBits = 8;
	settings.antialiasingLevel = 3;
	settings.attributeFlags=sf::ContextSettings::Core;
	sf::Window window(sf::VideoMode(WIDTH, HEIGHT,32), "SFML/OpenGL Ray Marching", sf::Style::Close, settings);
	window.setFramerateLimit(60); // Limit to 60 frames per second

	// Init Renderer/OpenGL
	Renderer renderer(WIDTH,HEIGHT);

	// Main loop
	bool running=true;
	while (running)
	{
		// gestion des évènements
		sf::Event event;
		while (window.pollEvent(event))
		{
			if (event.type == sf::Event::Closed)
				running=false;
			else if (event.type == sf::Event::Resized)
				renderer.AjustViewport(event.size.width,event.size.height);
			else if (event.key.code == sf::Keyboard::R)
				renderer.UpdateShader("square.glsl");
		}

		renderer.Render();
		window.display(); // Refresh screen
	}

	return 0;
}



